#include "Nd2MemoryTest.h"
//Open two adaptors listening to the same endpoint
//should get ND_CONNECTION_REFUSED

#pragma warning( disable : 4100 )
void Nd2DualListenServer::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
    //prep
    Nd2TestBase::Init(v4Src);
	Nd2TestServerBase::CreateListen();
	Nd2TestServerBase::Listen(v4Src);

	//open another adaptor listening to the same endpoint
	IND2Adapter* pAdapter;
	IND2Listener* pListen;
	HRESULT hr = NdOpenAdapter(
		IID_IND2Adapter,
		reinterpret_cast<const struct sockaddr*>(&v4Src),
		sizeof(v4Src),
		reinterpret_cast<void**>( &pAdapter)
	);
	if( FAILED( hr ) )
	{
		hr = NdShimOpenAdapter(
			IID_IND2Adapter,
			reinterpret_cast<const struct sockaddr*>(&v4Src),
			sizeof(v4Src),
			reinterpret_cast<void**>( &pAdapter )
		);
	}
   hr = m_pAdapter->CreateListener(
        IID_IND2Listener,
        m_hAdapterFile,
        reinterpret_cast<VOID**>( &pListen )
        );

   	hr = m_pListen->Bind(
        reinterpret_cast<const sockaddr*>( &v4Src ),
        sizeof( v4Src )
        );
	
	//second bind should fail
    LogIfErrorExit(hr,STATUS_ADDRESS_ALREADY_ASSOCIATED,"Second listen should fail",__LINE__);

}



#pragma warning( disable : 4100 )
void Nd2DualListenClient::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ const struct sockaddr_in& v4Dst,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
	//do nothing
}


