#include "Nd2MemoryTest.h"

//Create QP that exceeds maxReceiveQueueDepth advertised
//shoud get error message

void Nd2LargeQPDepthServer::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ DWORD queueDepth,
    _In_ DWORD /*nSge*/
    )
{
	//prep  
    Nd2TestBase::Init( v4Src);
	Nd2TestBase::CreateCQ(2);
	
	//get the max supported depth QP
	ND2_ADAPTER_INFO adaptorInfo;
	adaptorInfo.InfoVersion=ND_VERSION_2;
	ULONG infoSize = sizeof(ND2_ADAPTER_INFO);
	HRESULT hr = m_pAdapter->Query(&adaptorInfo,&infoSize);
	LogIfErrorExit(hr,ND_SUCCESS,"Querying dataptor info failed!",__LINE__);
	
	//create QP with depth exceeding max-supported depth
	queueDepth = adaptorInfo.MaxReceiveQueueDepth+1;
	
	hr = m_pAdapter->CreateQueuePair(
		IID_IND2QueuePair,
		m_pCq,
		m_pCq,
		NULL,
		queueDepth,
		1,
		2,
		2,
		0,
		reinterpret_cast<VOID**>( &m_pQp )
		);
		
	LogIfNoErrorExit(hr,"Receiving queue depth exceeding max value should error!",__LINE__);
}




#pragma warning( disable : 4100 )

void Nd2LargeQPDepthClient::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ const struct sockaddr_in& v4Dst,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
    //do nothing on the client

}
