#include "Nd2MemoryTest.h"

//Post a receive on local CP and close remote connector

void Nd2SendReceiveConnectorClosedServer::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{
	//prep
    Nd2TestBase::Init( v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer( x_HdrLen + x_MaxXfer+1,ND_MR_FLAG_ALLOW_LOCAL_WRITE,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge);
	Nd2TestBase::CreateConnector();
	Nd2TestBase::CreateQueuePair(queueDepth,nSge);
	Nd2TestServerBase::CreateListen();
	Nd2TestServerBase::Listen(v4Src);
	Nd2TestServerBase::GetConnectionRequest();

	//prepare Sge
	ND2_SGE* Sge=new ND2_SGE[nSge];
	Sge[0].Buffer = m_Buf;
	Sge[0].BufferLength =  x_HdrLen + x_MaxXfer;
	Sge[0].MemoryRegionToken = m_pMr->GetLocalToken();
	
	//Post receive  - should succeed
	Nd2TestBase::PostReceive(Sge,1);
	
	//Accept connection
	Nd2TestServerBase::Accept(1,1);

	//sleep 5 seconds to let client close the remote connector
	Sleep(5*1000);
    
	//expect 1 message for the posted receive
	WaitForCompletion(ND_CANCELED);

	//tear down
    Nd2TestBase::Shutdown();
}


void Nd2SendReceiveConnectorClosedClient::RunTest(
    _In_ const struct sockaddr_in& v4Src,
    _In_ const struct sockaddr_in& v4Dst,
    _In_ DWORD queueDepth,
    _In_ DWORD nSge
    )
{

    //prep
	Nd2TestBase::Init( v4Src);
	Nd2TestBase::CreateMR();
	Nd2TestBase::RegisterDataBuffer(x_MaxXfer,ND_MR_FLAG_ALLOW_LOCAL_WRITE,ND_SUCCESS,"Register memory with local read access failed");
	Nd2TestBase::CreateCQ(nSge,ND_SUCCESS);
	Nd2TestBase::CreateConnector();
	Nd2TestBase::CreateQueuePair(queueDepth,nSge);
	
	//connect
	Nd2TestClientBase::Connect(v4Src,v4Dst,1,1);
	Nd2TestClientBase::CompleteConnect();
	
	//shutdown immediately
    Nd2TestBase::Shutdown();
}
