@ECHO OFF
SET RUN32=-run32 $false
SET RUN64=-run64 $true
SET TESTNODEGROUP=-TestNodeGroup ComputeNodes
SET VERSION=-Version 1
SET RUNND=-runnd $true
SET RUNMPI=-runmpi $true
SET NODEGROUP=ComputeNodes
SET USER=
SET PASSWORD=

:Loop
IF [%1] == [] GOTO :EndLoop
IF [%1] == [/?] GOTO :USAGE
IF /I [%1] == [-TYPE] (
    IF /I [%2] == [ND] (
      SET RUNND=-runnd $true
      SET RUNMPI=-runmpi $false
    )
    IF /I [%2] == [MPI] (
      SET RUNND=-runnd $false
      SET RUNMPI=-runmpi $true
    )
    IF /I [%2] == [*] (
      SET RUNND=-runnd $true
      SET RUNMPI=-runmpi $true
    )
    GOTO :ShiftAndLoop
)
IF /I [%1] == [-ARCH] (
    IF /I [%2] == [AMD64] (
      SET RUN32=-run32 $false
      SET RUN64=-run64 $true
    )
    IF /I [%2] == [I386] (
      SET RUN32=-run32 $true
      SET RUN64=-run64 $false
    )
    IF /I [%2] == [*] (
      SET RUN32=-run32 $true
      SET RUN64=-run64 $true
    )
    GOTO :ShiftAndLoop
)
IF /I [%1] == [-NodeGroup] (
  SET TESTNODEGROUP=-TestNodeGroup %2
  SET NODEGROUP=%2 
  GOTO :ShiftAndLoop
)
IF /I [%1] == [-VERSION] (
    IF /I [%2] == [1] (
      SET VERSION=-Version 1
    )
    IF /I [%2] == [2] (
      SET VERSION=-Version 2
    )
    IF /I [%2] == [*] (
      SET VERSION=-Version 1,2
    )
    GOTO :ShiftAndLoop
)

IF /I [%1] == [-user] (
  SET USER=/user:%2
  GOTO :ShiftAndLoop
)

IF /I [%1] == [-password] (
  SET PASSWORD=/password:%2
  GOTO :ShiftAndLoop
)

:ShiftAndLoop
SHIFT
GOTO :Loop
:EndLoop
cluscfg setcreds %USER% %PASSWORD%
powershell -noninteractive -command "set-executionpolicy unrestricted"
clusrun /nodegroup:%NODEGROUP% powershell -noninteractive -command "set-executionpolicy unrestricted"
powershell -noninteractive -command ".\run-ndlogosuite.ps1 %RUNND% %RUNMPI% %RUN32% %RUN64% %TESTNODEGROUP% %VERSION%"
GOTO :EOF

:USAGE
  ECHO USAGE:  %~n0 ^[Optional Arguments^]
  ECHO -type     : The type of test, choose from nd, mpi or * for both
  ECHO             * The default value is *
  ECHO -version  : choose from ND version 1,2 or * for both
  ECHO             * The default value is 1
  ECHO -arch     : The architecture you wish to test, choose from amd64, i386 or * for both
  ECHO             * The default value is amd64
  ECHO -NodeGroup: Specify the name of your nodegroup to run ND tests on, default value is ComputeNodes
  ECHO -User     : Specify the user name to run your tests on
  ECHO -Password : Specify the password for the user

  echo Example: run-ndlogosuite.cmd -type nd -NodeGroup ComputeNodes -version 2 -arch amd64
EXIT /B 1
GOTO :EOF