﻿param([string] $cmd1="",
      [string] $cmd2="")

Add-PSSnapin Microsoft.Hpc
$jobid = $env:CCP_JOBID
$job=Get-HpcJob -Id $jobid
$allnodes=$job.allocatednodes
$servernodename=$allnodes.split(',')[0]
$servernodes=[System.Net.Dns]::GetHostAddresses("Application.$servernodename")
$serverip=$servernodes[0].IPAddressToString
echo "getting server ip $serverip"

$clientip=""
if($allnodes.split(',').count -gt 1)
{
    $clientnodename=$allnodes.split(',')[1]
    $clientnodes=[System.Net.Dns]::GetHostAddresses("Application.$clientnodename")
    $clientip=$clientnodes[0].IPAddressToString
    echo "getting client ip $clientip"
}


#if this is server node, run $cmd1
if($env:COMPUTERNAME -eq $servernodename)
{
    echo "running as server on $env:COMPUTERNAME"
    $cmd=$cmd1
}
#if not, run $cmd2
else
{
    echo "running as client on $env:COMPUTERNAME"
    $cmd=$cmd2
    echo "Waiting for 2 seconds"
    #non-server should wait 2 seconds
    Sleep 2
}
#process the cmds here, replacing "serverip" with $serverip, "clientip" with $clientip
$cmd=$cmd.Replace("serverip",$serverip)
if($clientip -ne "")
{
    $cmd=$cmd.Replace("clientip",$clientip)
}
echo "running $cmd"
cmd /c $cmd
if($LASTEXITCODE -ne 0)
{
    $errs=$LASTEXITCODE
    echo "command failed on node $env:COMPUTERNAME with error code $LASTEXITCODE,repro step $cmd"
}

exit $errs

